# -*- coding: utf-8 -*-
import sys,os,time
sys.path.append('.')
from include import plugins
from PyQt4 import QtCore, QtGui
from urllib import quote, unquote
from twisted.python import log
from include import utils
import base64
from widgets import dataforms,legacyforms
from widgets.events.ftwidget import FTDownloadWidget
from twisted.internet import reactor
try:
	from hashlib import md5
except:
	log.msg('Please upgrade to python2.5')
	from md5 import new as md5

if sys.platform=="win32":
	import _winreg

class config:
	def __init__(self,main):
		self.main=main
		self.config={}
		self.config['iconMode']={'type':'boolean','label':self.main.tr("Show files as icons"),'value':'True'}
class Plugin(plugins.PluginBase):
	def __init__(self,main, homedir, plugindir):
		plugins.PluginBase.__init__(self, main, homedir, plugindir)
		self.fname = 'jdm'
		self.installTranslator()
		self.description = self.tr('Jabbim disk manager')
		self.author = u"Josef 'Pepeq' Halíček"
		self.name = self.tr('JDM Plugin')
		self.version = '0.1148'
		self.category = ['utils']
		self.url = 'http://dev.jabbim.cz/jabbim'
		self.configDialog=config(self)
		if main:
			self.loadConfig()
			self.window = self.loadWindow("%s/jdm_ui.py" % self.pluginDir,self.main)
			self.wizard = self.loadDialog("%s/jdw_ui.py" % self.pluginDir,self.main)
			self.downloadQueue=[]
			self.window.setWindowIcon(self.main.windowIcon())
##			self.window.ui.list.setContextMenuPolicy(QtCore.Qt.CustomContextMenu)
##			self.window.ui.list.startDrag=self.startDrag
##			self.window.ui.list.setAcceptDrops(True)
##			self.window.ui.list.dropEvent = self.dropEvent
##			self.window.ui.list.dragMoveEvent = self.dragMoveEvent
##			self.window.ui.list.dragEnterEvent = self.dragEnterEvent
##			self.window.ui.line_jid.setText(self.main.client.jid.userhost())
			self.typ = "public"
			self.callTab=None
			self.thumbIndex=0
			self.esPath=""
			self.wizard.ui.download.setIcon(QtGui.QIcon("%s/document-save.png" % self.pluginDir))
			self.wizard.ui.upload.setIcon(QtGui.QIcon("%s/upload.png" % self.pluginDir))
			self.wizard.ui.remove.setIcon(QtGui.QIcon("%s/edit-delete.png" % self.pluginDir))
			self.window.ui.buttonHome.setIcon(QtGui.QIcon("%s/home.png" % self.pluginDir))
			self.window.ui.publicButton.setIcon(QtGui.QIcon("%s/jdisk-public-24.png" % self.pluginDir))
			self.window.ui.privateButton.setIcon(QtGui.QIcon("%s/jdisk-private-24.png" % self.pluginDir))
			self.window.ui.album.setIcon(QtGui.QIcon("%s/jalbum-32.png" % self.pluginDir))
			self.window.ui.easyshare.setIcon(QtGui.QIcon("%s/easy_share32.png" % self.pluginDir))
			self.wizard.ui.public.setIcon(QtGui.QIcon("%s/jdisk-public-24.png" % self.pluginDir))
			self.wizard.ui.private.setIcon(QtGui.QIcon("%s/jdisk-private-24.png" % self.pluginDir))
			self.wizard.ui.album.setIcon(QtGui.QIcon("%s/jalbum-32.png" % self.pluginDir))
			self.wizard.ui.es.setIcon(QtGui.QIcon("%s/easy_share32.png" % self.pluginDir))
			self.wizard.ui.filename.setText('')
			self.wizard.ui.filesize.setText('')
			self.window.ui.showMiniRoster.setIcon(self.main.ui.mainTabWidget.tabIcon(0))
			self.group=QtGui.QButtonGroup(self.window)
			self.group.setExclusive(False)
			self.update=False

			QtCore.QObject.connect(self.group,QtCore.SIGNAL("buttonClicked ( QAbstractButton * )"),self.buttonClicked)
##			QtCore.QObject.connect(self.window.ui.reload,QtCore.SIGNAL("clicked()"),self.call)
##			QtCore.QObject.connect(self.window.ui.esUp,QtCore.SIGNAL("clicked()"),self.esUp)
##			QtCore.QObject.connect(self.window.ui.esPath,QtCore.SIGNAL("returnPressed()"),self.esPathFinished)
			QtCore.QObject.connect(self.wizard.ui.tree, QtCore.SIGNAL("itemSelectionChanged ( )"),self.selectionChanged)
##			QtCore.QObject.connect(self.window.ui.list,QtCore.SIGNAL("customContextMenuRequested ( const QPoint & )"),self.fileMenu)
			QtCore.QObject.connect(self.wizard.ui.tree,QtCore.SIGNAL("customContextMenuRequested ( const QPoint & )"),self.fileMenu)
			QtCore.QObject.connect(self.window.ui.buttonDownload,QtCore.SIGNAL("clicked()"),self.downloadCurrentFile)
			QtCore.QObject.connect(self.window.ui.buttonDelete,QtCore.SIGNAL("clicked()"),self.removeCurrentFile)
			QtCore.QObject.connect(self.window.ui.buttonUpload,QtCore.SIGNAL("clicked()"),self.sendFile)
			QtCore.QObject.connect(self.window.ui.buttonHome,QtCore.SIGNAL("clicked()"),self.home)
			QtCore.QObject.connect(self.window.ui.publicButton,QtCore.SIGNAL("clicked()"),self.public)
			QtCore.QObject.connect(self.window.ui.privateButton,QtCore.SIGNAL("clicked()"),self.private)
			QtCore.QObject.connect(self.window.ui.album,QtCore.SIGNAL("clicked()"),self.album)
			QtCore.QObject.connect(self.window.ui.easyshare,QtCore.SIGNAL("clicked()"),self.easyshare)
			QtCore.QObject.connect(self.wizard.ui.public,QtCore.SIGNAL("clicked()"),self.public)
			QtCore.QObject.connect(self.wizard.ui.private,QtCore.SIGNAL("clicked()"),self.private)
			QtCore.QObject.connect(self.wizard.ui.album,QtCore.SIGNAL("clicked()"),self.album)
			QtCore.QObject.connect(self.wizard.ui.es,QtCore.SIGNAL("clicked()"),self.easyshare)
			QtCore.QObject.connect(self.wizard.ui.back,QtCore.SIGNAL("clicked()"),self.wBack)
			QtCore.QObject.connect(self.wizard.ui.download,QtCore.SIGNAL("clicked()"),self.downloadCurrentFile)
			QtCore.QObject.connect(self.wizard.ui.remove,QtCore.SIGNAL("clicked()"),self.removeCurrentFile)
			QtCore.QObject.connect(self.wizard.ui.upload,QtCore.SIGNAL("clicked()"),self.sendFile)
			QtCore.QObject.connect(self.wizard.ui.configuration,QtCore.SIGNAL("clicked()"),self.esConfiguration)
			QtCore.QObject.connect(self.window.ui.showMiniRoster,QtCore.SIGNAL("clicked()"),self.showMiniRoster)
			QtCore.QObject.connect(self.window.ui.desktop,QtCore.SIGNAL("clicked()"),self.leftDesktop)
			QtCore.QObject.connect(self.window.ui.computer,QtCore.SIGNAL("clicked()"),self.leftComputer)
			QtCore.QObject.connect(self.window.ui.right,QtCore.SIGNAL("itemDoubleClicked ( QTreeWidgetItem *,int )"),self.doubleClicked)
			QtCore.QObject.connect(self.wizard.ui.tree,QtCore.SIGNAL("itemDoubleClicked ( QListWidgetItem *)"),self.doubleClicked)

			self.wizard.ui.configuration.hide()
			
			self.model=QtGui.QDirModel()
			self.model.supportedDropActions=self.supportedDropActions
			self.model.flags=self.flags
			self.model.setReadOnly(False)
			self.window.ui.left.setModel(self.model)
			self.window.ui.left.setDragEnabled(True)
			self.window.ui.left.setAcceptDrops(True)
			self.window.ui.left.startDrag=self.leftStartDrag
			self.window.ui.left.dropMimeData=self.leftDropMimeData
			self.window.ui.left.mimetypes=self.mimeTypes
			self.window.ui.left.setDropIndicatorShown(True)
			self.window.ui.left.setDragDropMode(QtGui.QAbstractItemView.DragDrop)
			self.window.ui.left.dragEnterEvent=self.dragEnterEvent
			self.window.ui.left.dragMoveEvent = self.dragMoveEvent
			self.window.ui.left.dropEvent = self.dropEvent
			
			self.wizard.ui.l=QtGui.QVBoxLayout(self.wizard.ui.prog)
			
			
			self.window.ui.right.dropMimeData=self.rightDropMimeData
			self.window.ui.right.startDrag=self.rightStartDrag
			self.window.ui.right.mimeTypes=self.mimeTypes
			self.window.ui.right.setDragEnabled(True)
			self.window.ui.right.setAcceptDrops(True)

			self.log = False
			self.registerHandler('on_message', self.on_message, priority=4)
			self.registerHandler('on_ftEnd', self.on_ftEnd, priority = 4)
			self.registerHandler('FTDownloadEvent', self.FTDownloadEvent)
			self.registerHandler('FTFileReceivedEvent', self.FTFileReceivedEvent)
			self.obsah=[]
			self.dnd={}
			if not os.path.exists(self.main.realHomeDir+"/jdmcache"):
				os.mkdir(self.main.realHomeDir+"/jdmcache")
			self.cache=self.main.realHomeDir+"/jdmcache"
			self.cacheList=self.getConfig(self.cache+"/list.cfg")
			self.filesToOpen=[]
			self.window.ui.progress=QtGui.QProgressBar(self.window.ui.statusbar)
			self.window.ui.statusbar.addWidget(self.window.ui.progress,1)
			self.window.ui.progress.hide()
			self.leftDesktop()
			self.stopDownload=False

			#desktop integration
			self.registerHandler('on_pluginsLoaded', self.registerRemote)
			
		else:
			self.loadConfig(homedir)

	def clientCreated(self):
		self.jid = self.main.client.jid.userhost()
		plugins.PluginBase.clientCreated(self)

	def registerRemote(self):
		remote = self.main.getPlugin('remote')
		if remote != False and remote != None:
			remote.registerPluginFunc('jdm_public', self.remotePublic)
			utils.regWindowsMenu('Send to JDM Public', 'jdm_public')
			remote.registerPluginFunc('jdm_private', self.remotePrivate)
			utils.regWindowsMenu('Send to JDM Private', 'jdm_private')

	def unregisterRemote(self):
		remote = self.main.getPlugin('remote')
		if remote != False and remote != None:
			remote.unregisterPluginFunc('jdm_public')
			utils.unregWindowsMenu('Send to JDM Public')
			remote.unregisterPluginFunc('jdm_private')
			utils.unregWindowsMenu('Send to JDM Private')
        	
	def remotePublic(self, arg):
		self.main.showFiletransferDialog([arg], 'public@disk.jabbim.cz')
	def remotePrivate(self, arg):
		self.main.showFiletransferDialog([arg], 'private@disk.jabbim.cz')

	def on_remove(self):
		self.unregisterRemote()
		
	def esConfiguration(self):
		self.showPluginConfigDialog("easyshare",self.wizard)
		self.easyshare()

	def wBack(self):
		self.wizard.ui.back.hide()
		if self.wizard.ui.stackedWidget.currentIndex()==2:
			self.wizard.progress.reject()
		self.wizard.ui.stackedWidget.setCurrentIndex(0)

	def FTFileReceivedEvent(self,event):
		if not event() or (self.window.isHidden() and self.wizard.isHidden()):
			return
		event().accept()

	def FTDownloadEvent(self,event):
		if not event() or (self.window.isHidden() and self.wizard.isHidden()):
			return
		#self.w=QtGui.QDialog(self.window)
		try:
			self.wizard.progress.ui
			self.wizard.progress.reject()
		except:
			pass
		self.wizard.progress=FTDownloadWidget(event())
		self.wizard.progress.setParent(self.wizard.ui.prog)
		self.wizard.ui.l.addWidget(self.wizard.progress)
		#self.wizard.progress.eventAccepted=self.eventAccepted
		self.wizard.progress.eventRejected=self.eventRejected
		self.wizard.progress.transferFinished=self.tFinished
		self.wizard.ui.stackedWidget.setCurrentIndex(2)
		self.wizard.progress.show()
		event().addWidget(self.wizard.progress)

	def tFinished(self):
		self.wizard.progress.ui.progressBar.hide()
		self.wizard.progress.ui.accept.show()
		self.wizard.progress.ui.transferInfo.setText(self.tr("Finished"))
		self.wizard.progress.ui.reject.hide()
		
	def eventRejected(self):
		self.wizard.progress.hide()
		self.wizard.ui.l.removeWidget(self.wizard.progress)
		self.wizard.progress.setParent(None)
		self.wizard.progress.deleteLater()
		del self.wizard.progress
		

	def dragEnterEvent(self, event):
		log.msg("left drag enter")
		if event.mimeData().hasText() or event.mimeData().hasFormat("text/uri-list"):
			event.acceptProposedAction()
		else:
			event.ignore()

	def flags(self,index):
		defaultFlags = QtGui.QDirModel.flags(self.model,index)
		return QtCore.Qt.ItemIsDragEnabled | QtCore.Qt.ItemIsDropEnabled | defaultFlags

	def supportedDropActions(self):
		return QtCore.Qt.CopyAction | QtCore.Qt.MoveAction

	def mimeTypes(self):
		# set mimetypes, which we accept
		return QtCore.QStringList(["text/plain","text/uri-list"])

	def leftDropMimeData(self,parent,index,data,action):
		path=unicode(self.model.fileInfo(index).absoluteFilePath())
		log.msg("left drop" + path)
		return True

	def rightDropMimeData(self,parent,index,data,action):
		new=[]
		if (data.hasUrls()):
			urlList=data.urls()
			if len(urlList)>0:
				for url in urlList:
					f=unicode(url.toLocalFile())
					if len(f)!=0:
						new.append(f)
		else:
			new=[unicode(data.text())]
		file=new
		if self.typ=="public":
			self.main.showFiletransferDialog(file, 'public@disk.jabbim.cz')
		elif self.typ=="private":
			self.main.showFiletransferDialog(file, 'private@disk.jabbim.cz')
		elif self.typ=="album":
			self.main.showFiletransferDialog(file, 'album@disk.jabbim.cz')
		return True

	def rightStartDrag(self,actions):
		# start dragging selected contact
		path=unicode(self.window.ui.right.currentItem().text(0))
		print "right drag",path
		self.window.ui.right.drag=QtGui.QDrag(self.window.ui.right)
		mimeData=QtCore.QMimeData()
		mimeData.setText(path)
		self.window.ui.right.drag.setMimeData(mimeData)
		self.window.ui.right.action=self.window.ui.right.drag.start(QtCore.Qt.CopyAction)

	def leftStartDrag(self,actions):
		# start dragging selected contact
		path=unicode(self.model.fileInfo(self.window.ui.left.currentIndex()).absoluteFilePath())
		print "left drag",path
		if os.path.isdir(path):
			#TODO easyshare
			return
		else:
			self.window.ui.left.drag=QtGui.QDrag(self.window.ui.left)
			mimeData=QtCore.QMimeData()
			mimeData.setText(path)
			self.window.ui.left.drag.setMimeData(mimeData)
			self.window.ui.left.action=self.window.ui.left.drag.start(QtCore.Qt.CopyAction)

	def leftDesktop(self):
##		HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Desktop
		folder=None
		if sys.platform=="win32":
			hkcu = _winreg.ConnectRegistry(None, _winreg.HKEY_CURRENT_USER)
			folders=_winreg.OpenKey(hkcu, r'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders')
			try:
				(folder, typ) = _winreg.QueryValueEx(folders, "Desktop")
			except WindowsError:
				folder=None
		if folder:
			self.window.ui.left.setRootIndex(self.model.index(unicode(folder)))

	def leftComputer(self):
		self.window.ui.left.setRootIndex(self.model.index("/"))

	def esPathFinished(self):
		self.esPath=unicode(self.window.ui.esPath.text())
		if not self.esPath.endswith("/") and self.esPath!="":
			self.espath+="/"
		if self.esPath=="":
			self.easyshare()
		else:
			contact = self.main.client.getContactByJid(self.jid)
			jid=self.jid+"/"+contact.getHighestResource()
			#self.window.ui.esPath.setText(self.esPath)
			self.main.client.callRemote(jid, 'listShare',(unicode(self.esPath),)).addCallback(self.updateView)

	def esUp(self):
		d=self.esPath.split("/")
		if len(d)>2:
			self.esPath='/'.join(d[:-2])+"/"
			contact = self.main.client.getContactByJid(self.jid)
			jid=self.jid+"/"+contact.getHighestResource()
			self.window.ui.esPath.setText(self.esPath)
			self.main.client.callRemote(jid, 'listShare',(unicode(self.esPath),)).addCallback(self.updateView)
		elif len(self.esPath)!=0:
			self.easyshare()
	
	def easyshare(self):
		contact = self.main.client.getContactByJid(self.jid)
		if contact:
			jid=self.jid+"/"+contact.getHighestResource()
			self.main.client.callRemote(jid, 'getShares',()).addCallback(self.esGotShares)
			self.typ='easyshare'
			self.esPath=""
			#self.window.ui.esPath.setText(self.esPath)
##			self.window.ui.esWidget.show()
	
	def esGotShares(self,data):
		data=data[0][0]
		
		#self.window.ui.esPath.setText(self.esPath)
		#self.window.ui.list.clear()
		#self.window.ui.right.clear()
		self.wizard.ui.tree.clear()
		icon=QtGui.QIcon(self.pluginDir+"/folder.png")
		for d in data:
			#item=QtGui.QTreeWidgetItem(self.window.ui.right)
			item=QtGui.QListWidgetItem(self.wizard.ui.tree)
			item.setData(32,QtCore.QVariant(QtCore.QStringList([u"-1"])))
			item.setText(unicode(d))
			item.setIcon(icon)
			item.path=unicode(d)+"/"
		self.wizard.ui.stackedWidget.setCurrentIndex(1)
		self.wizard.ui.back.show()
		self.wizard.ui.remove.hide()
		self.wizard.ui.upload.hide()
		if self.jid==self.main.client.jid.userhost():
			self.wizard.ui.configuration.show()
		else:
			self.wizard.ui.configuration.hide()

	def buildContactMenu(self,menu,contact):
		"""
		Adds QAction to the menu above contact 
		"""
		self.action=menu.addAction(self.tr("Jabber Disk"))
		self.action.setData(QtCore.QVariant(unicode(contact.jid)))
		self.action.setObjectName("jdm_show_jdisk")
		self.action.setIcon(QtGui.QIcon("%s/jdisk-public-24.png" % self.pluginDir))
		QtCore.QObject.connect(self.action,QtCore.SIGNAL("triggered ( bool )"),self.contactMenuToggled)

	def contactMenuToggled(self,b):
		"""
		User choose our QAction from contactMenu (menu above contact)
		"""
		jid=unicode(self.action.data().toString())
		self.showSlot(jid)
		self.action.deleteLater()

	def showMiniRoster(self):
		self.main.ui.roster.showMiniRoster(self.miniRosterAccepted)
	
	def miniRosterAccepted(self,jid):
		self.call(jid,'public')
		

	def setIconMode(self,bool):
		if bool:
			if self.typ=="album":
				self.window.ui.list.setGridSize(QtCore.QSize(160,160))
			else:
				self.window.ui.list.setGridSize(QtCore.QSize(128,96))
			self.window.ui.list.setViewMode(QtGui.QListView.IconMode)
			self.config["iconMode"]='True'
		else:
			self.window.ui.list.setGridSize(QtCore.QSize())
			self.window.ui.list.setViewMode(QtGui.QListView.ListMode)
			self.config["iconMode"]='False'
		self.config.write()

	def public(self):
##		self.window.ui.esWidget.hide()
		self.call(typ='public')

	def private(self):
##		self.window.ui.esWidget.hide()
		self.call(typ='private')

	def album(self):
##		self.window.ui.esWidget.hide()
		self.call(typ='album')

	def home(self):
		self.call(self.main.client.jid.userhost())

	def buttonClicked(self,button):
		if button.typ=="album":
			self.showSlot(unicode(button.jid), typ="album")
	#		if button.isChecked():
	#			tab,i=self.main.chat.findTab(unicode(button.jid))
#				if tab:
#					tab.chat.ui.webkit.page().mainFrame().evaluateJavaScript('var group = document.createElement(\'div\'); group.innerHTML="<div id=\\"light\\" style=\\"position: fixed;top: 10%;right:10%;left: 10%;width: 80%;height: 70%;padding: 16px;background-color: white;z-index:1002;border: 1px solid black;overflow: auto;\\"></div>";document.body.appendChild(group);')
#					self.callTab=tab
#					self.call(unicode(button.jid),"album")
#			else:
#				tab,i=self.main.chat.findTab(unicode(button.jid))
#				if tab:
#					tab.chat.ui.webkit.page().mainFrame().evaluateJavaScript("removeById(\'light\');")
		else:
			self.showSlot(unicode(button.jid), typ="public")
#			if button.isChecked():
#				tab,i=self.main.chat.findTab(unicode(button.jid))
#				if tab:
#					tab.chat.ui.webkit.page().mainFrame().evaluateJavaScript('var group = document.createElement(\'div\'); group.innerHTML="<div id=\\"light\\" style=\\"position: fixed;top: 10%;right:10%;left: 10%;width: 80%;height: 70%;padding: 16px;background-color: white;z-index:1002;border: 1px solid black;overflow: auto;\\"></div>";document.body.appendChild(group);')
#					self.callTab=tab
#					self.call(unicode(button.jid),"public")
#			else:
#				tab,i=self.main.chat.findTab(unicode(button.jid))
#				if tab:
#					tab.chat.ui.webkit.page().mainFrame().evaluateJavaScript("removeById(\'light\');")
			

	def chatMenuItemTriggered(self,action):
		cmd=unicode(action.objectName())
		if cmd=="show_my_disk":
			tab,i=self.main.chat.findTab(unicode(action.parent().parent().jid))
			print tab,i
			if tab:
				tab.chat.ui.webkit.page().mainFrame().evaluateJavaScript('var group = document.createElement(\'div\'); group.innerHTML="<div id=\\"light\\" style=\\"position: fixed;top: 10%;right:10%;left: 10%;width: 80%;height: 70%;padding: 16px;background-color: white;z-index:1002;border: 1px solid black;overflow: auto;\\"><a href = \\"javascript:void(0)\\" onclick = \\"removeById(\'light\');\\">Close</a></div>";document.body.appendChild(group);')
				self.callTab=tab
				self.call(unicode(action.parent().parent().jid),"album")
			#anchor="http://disk.jabbim.cz/%s/"%(unicode(self.main.client.jid.userhost()))
			#QtGui.QDesktopServices.openUrl(QtCore.QUrl(anchor))
		elif cmd=="show_users_disk":
			anchor="http://disk.jabbim.cz/%s/"%(unicode(action.parent().parent().jid))
			QtGui.QDesktopServices.openUrl(QtCore.QUrl(anchor))
		elif cmd=="show_my_disk_jdm":
			self.showSlot(self.main.client.jid.userhost())
		elif cmd=="show_my_album_jdm":
			self.showSlot(self.main.client.jid.userhost(),typ='album')
		elif cmd=="show_users_disk_jdm":
			self.showSlot(unicode(action.parent().parent().jid))
		elif cmd=="show_users_album_jdm":
			self.showSlot(unicode(action.parent().parent().jid),typ="album")
		elif cmd=="show_my_album":
			anchor="http://album.jabbim.cz/%s/"%(unicode(self.main.client.jid.userhost()))
			QtGui.QDesktopServices.openUrl(QtCore.QUrl(anchor))
		elif cmd=="show_users_album":
			anchor="http://album.jabbim.cz/%s/"%(unicode(action.parent().parent().jid))
			QtGui.QDesktopServices.openUrl(QtCore.QUrl(anchor))

	def buildChatWidget(self,jid,layout,widget):
		jid=self.main.getJid(jid)
		# create Archive button
		button=QtGui.QPushButton()
		button.setCheckable(False)
		button.setIconSize(QtCore.QSize(16,16))
		button.setIcon(QtGui.QIcon("%s/jalbum-32.png" % self.pluginDir))
		button.jid=unicode(jid.userhost())
		button.typ="album"
		button.setToolTip("Show Photos")
		#button.setText(self.tr("Show Photos"))
		# add button to buttonGroup
		self.group.addButton(button)
		layout.addWidget(button)

		button=QtGui.QPushButton()
		button.setCheckable(False)
		button.setIconSize(QtCore.QSize(16,16))
		button.setIcon(QtGui.QIcon("%s/jdisk-public.png" % self.pluginDir))
		button.jid=unicode(jid.userhost())
		button.typ="public"
		button.setToolTip("Show Jdisk")
		#button.setText(self.tr("Show Jdisk"))
		# add button to buttonGroup
		self.group.addButton(button)
		layout.addWidget(button)

		w=QtGui.QWidget()
		l=QtGui.QHBoxLayout(w)
		w.label1=QtGui.QLabel(w)
		l.addWidget(w.label1)
		w.label2=QtGui.QLabel(w)
		l.addWidget(w.label2)
		w.label3=QtGui.QLabel(w)
		l.addWidget(w.label3)

		widget.addCoolWidget(w)

		self.main.client.callRemote('rpc@jabbim.cz/service', 'listPublic', (jid.userhost(),)).addCallback(self.setStatsPublic,widget)
		self.main.client.callRemote('rpc@jabbim.cz/service', 'listAlbum', (jid.userhost(),)).addCallback(self.setStats,widget,w)

	def setStatsPublic(self,data,widget):
		data=data[0][0]
		if len(data)>0:
			widget.addInfoText("jdm_public",widget.name+" "+unicode(self.tr("has %s files in Public Disc." % str(len(data)))))

	def setStats(self,data,widget,w):
		data=data[0][0]
		if len(data)>0:
			widget.addInfoText("jdm_album",widget.name+" "+unicode(self.tr("has %s photos in his album." % str(len(data)))))
			self.main.client.callRemote('rpc@jabbim.cz/service', 'getThumb', (self.main.getJid(widget.jid).userhost(),data[0][0])).addCallback(self.statsThumbArrived,data,w,widget)

	def statsThumbArrived(self,thumb,data,w,widget):
		cacheFile="%s/%s.jpg" % (self.cache,self.main.getJid(widget.jid).userhost()+data[0][0])
		if thumb:
			print "saving",data[0]
			image=base64.decodestring(str(thumb[0]))
			pixmap=QtGui.QPixmap()
			pixmap.loadFromData(image)
			#self.thumbs[data[0]].setIcon(QtGui.QIcon(pixmap))
			f=open(cacheFile,"wb")
			f.write(image)
			f.close()
			self.cacheList[cacheFile] = md5(image).hexdigest()
			self.cacheList.write()
		else:
			pixmap=QtGui.QPixmap(cacheFile)

		pixmap=pixmap.scaled(64,64,QtCore.Qt.KeepAspectRatio,QtCore.Qt.SmoothTransformation)
		if not w.label1.pixmap():
			w.label1.setPixmap(pixmap)
		elif not w.label2.pixmap():
			w.label2.setPixmap(pixmap)
		elif not w.label3.pixmap():
			w.label3.setPixmap(pixmap)
			return
		else:
			return

		del data[0]
		if len(data)!=0:
			if not self.stopDownload:
				cacheFile="%s/%s.jpg" % (self.cache,self.main.getJid(widget.jid).userhost()+data[0][0])
				if os.path.isfile(cacheFile):
					self.main.client.reactor.callLater(0,self.statsThumbArrived,None,data,w,widget)
				else:
					self.main.client.callRemote('rpc@jabbim.cz/service', 'getThumb', (self.main.getJid(widget.jid).userhost(),data[0][0])).addCallback(self.statsThumbArrived,data,w,widget)


		#button=QtGui.QToolButton()
		#button.setPopupMode(QtGui.QToolButton.InstantPopup)
		#button.setArrowType(QtCore.Qt.NoArrow)
		#button.setIconSize(QtCore.QSize(16,16))
		#button.setIcon(QtGui.QIcon("%s/jdisk-public.png" % self.pluginDir))
		#button.jid=unicode(jid.userhost())
		#button.setToolTip("Jabbim Album")
		## add button to buttonGroup
		#menu=QtGui.QMenu(button)
		## my
		#action=menu.addAction(self.tr("Show my Jdisk in JDM"))
		#action.setObjectName("show_my_disk_jdm")
		#action=menu.addAction(self.tr("Show my Album in JDM"))
		#action.setObjectName("show_my_album_jdm")
		#action=menu.addAction(self.tr("Show my Jdisk in browser"))
		#action.setObjectName("show_my_disk")
		#action=menu.addAction(self.tr("Show my Album in browser"))
		#action.setObjectName("show_my_album")
		#menu.addSeparator()
		## users
		#action=menu.addAction(self.tr("Show users Jdisk in JDM"))
		#action.setObjectName("show_users_disk_jdm")
		#action=menu.addAction(self.tr("Show users Album in JDM"))
		#action.setObjectName("show_users_album_jdm")
		#action=menu.addAction(self.tr("Show users Jdisk in browser"))
		#action.setObjectName("show_users_disk")
		#action=menu.addAction(self.tr("Show users Album in browser"))
		#action.setObjectName("show_users_album")
		#QtCore.QObject.connect(menu, QtCore.SIGNAL("triggered ( QAction *)"),self.chatMenuItemTriggered)
		#button.setMenu(menu)
		#layout.addWidget(button)



	def sendFile(self):
		if self.typ=="public":
			self.main.sendFiles('public@disk.jabbim.cz')
		elif self.typ=="private":
			self.main.sendFiles('private@disk.jabbim.cz')
		elif self.typ=="album":
			self.main.sendFiles('album@disk.jabbim.cz')

##	def startDrag(self,actions):
##		# start dragging selected contact
##		item=self.window.ui.list.currentItem()
##
##		self.drag=QtGui.QDrag(self.window.ui.list)
##		mimeData=QtCore.QMimeData()
##		mimeData.setText("http://disk.jabbim.cz/"+self.main.client.jid.userhost()+"/"+item.text())
##		mimeData.setUrls([QtCore.QUrl("http://disk.jabbim.cz/"+self.main.client.jid.userhost()+"/"+item.text())])
##		self.dnd=item
##		self.drag.setMimeData(mimeData)
##		self.action=self.drag.start(QtCore.Qt.CopyAction)
##
	def dropEvent(self, event):
		print "left drop event"
		if event.mimeData().hasText():
			f=unicode(event.mimeData().text())
			index=self.window.ui.left.indexAt(event.pos())
			path=unicode(self.model.fileInfo(index).absoluteFilePath())
			if not os.path.isdir(path):
				path=os.path.dirname(path)
			print "left drop",path
			if self.typ=="public":
				self.main.allowedJids["public@disk.jabbim.cz/"+unicode(f)]=path
				self.main.client.sendMessage("public@disk.jabbim.cz", u"get "+self.jid+" "+unicode(f))
				#self.filesToOpen.append(self.cache+"/"+unicode(item.text()))
			elif self.typ=="private":
				self.main.allowedJids["private@disk.jabbim.cz/"+unicode(f)]=path
				self.main.client.sendMessage("private@disk.jabbim.cz", u"get "+self.jid+" "+unicode(f))
				#self.filesToOpen.append(self.cache+"/"+unicode(item.text()))
			elif self.typ=="album":
				self.main.allowedJids["album@disk.jabbim.cz/"+unicode(f)]=path
				self.main.client.sendMessage("album@disk.jabbim.cz", u"get "+self.jid+" "+unicode(f))
				#self.filesToOpen.append(self.cache+"/"+unicode(item.text()))
			elif self.typ=="easyshare":
				contact = self.main.client.getContactByJid(self.jid)
				if contact:
					jid=self.jid+"/"+contact.getHighestResource()
					data=[]
					items=self.window.ui.right.selectedItems()
					for item in items:
						data.append(self.getPath(item))
					self.main.client.callRemote(jid, 'getFiles',(data,))


			event.acceptProposedAction()
##
	def dragMoveEvent(self, event):
		index=self.window.ui.left.indexAt(event.pos())
		if index:
			self.window.ui.left.setCurrentIndex(index)
		event.acceptProposedAction()
##	def dragEnterEvent(self, event):
##		if event.mimeData().hasText() or event.mimeData().hasFormat("text/uri-list"):
##			event.acceptProposedAction()
##		elif event.mimeData().hasText():
##			if self.main.getJid(unicode(event.mimeData().text())):
##				event.acceptProposedAction()
##			else:
##				event.ignore()
##		else:
##			event.ignore()
			
	def fileMenu(self,pos):
		items=self.wizard.ui.tree.selectedItems()
		self.menu=QtGui.QMenu()
		#action=self.menu.addAction(self.tr("Show files as icons"))
		#action.setCheckable(True)
		#if self.config['iconMode']=="True":
			#action.setChecked(True)
		#else:
			#action.setChecked(False)
		#QtCore.QObject.connect(action,QtCore.SIGNAL("triggered ( bool)"),self.setIconMode)
		if len(items)!=0:
			if len(items)>1:
				self.menu.addAction(self.tr("Download files"),self.downloadCurrentFile)
				if self.jid==self.main.client.jid.userhost():
					self.menu.addAction(self.tr("Remove files"),self.removeCurrentFile)
				if self.typ!="private":
					self.menu.addAction(self.tr("Copy links to clipboard"),self.copyToClipboard)
			
			else:
				self.menu.addAction(self.tr("Download file"),self.downloadCurrentFile)
				if self.jid==self.main.client.jid.userhost():
					self.menu.addAction(self.tr("Remove file"),self.removeCurrentFile)
				if self.typ!="private":
					self.menu.addAction(self.tr("Copy link to clipboard"),self.copyToClipboard)
				if self.typ != 'easyshare':
					self.menu.addAction(self.tr('Rename'), self.renameFile)
			if self.typ != 'easyshare':
					submenu = self.menu.addMenu(self.tr('Move to'))
					if self.typ == 'public':
						submenu.addAction('private', self.moveToPrivate)
						submenu.addAction('album', self.moveToAlbum)
					elif self.typ == 'private':
						submenu.addAction('public', self.moveToPublic)
						submenu.addAction('album', self.moveToAlbum)
					elif self.typ == 'album':
						submenu.addAction('public', self.moveToPublic)
						submenu.addAction('private', self.moveToPrivate)
				
			self.menu.popup(self.wizard.ui.tree.mapToGlobal(pos))
	
	def moveToAlbum(self):
		self.moveFiles(self.typ, 'album')
	
	def moveToPublic(self):
		self.moveFiles(self.typ, 'public')
	
	def moveToPrivate(self):
		self.moveFiles(self.typ, 'private')
	
	def moveFiles(self, odkud, kam):
		items=self.wizard.ui.tree.selectedItems()
		if len(items)==0:
			return		
		for item in items:
			self.main.client.sendMessage(odkud+"@disk.jabbim.cz", u"move "+unicode(item.text(0))+" "+kam)
		self.call(typ=self.typ)
		
	def renameFile(self):
		items=self.wizard.ui.tree.selectedItems()
		item = items[0]
		name,b=QtGui.QInputDialog.getText(self.main,self.tr("Rename"),self.tr("Enter new name:"), QtGui.QLineEdit.Normal, item.text(0))
		name=unicode(name)
		# if user set new name
		if b==True and len(name)!=0:
				if self.typ=="public":
					self.main.client.sendMessage("public@disk.jabbim.cz", u"ren "+unicode(item.text(0))+" "+name)
					self.public()
				elif self.typ=="private":
					self.main.client.sendMessage("private@disk.jabbim.cz", u"ren "+unicode(item.text(0))+" "+name)
					self.private()
				elif self.typ=="album":
					self.main.client.sendMessage("album@disk.jabbim.cz", u"ren "+unicode(item.text(0))+" "+name)
					self.album()

	def copyToClipboard(self):
		items=self.wizard.ui.tree.selectedItems()
		if len(items)==0:
			return
		text=""
		for item in items:
			if self.typ=="public":
				text+="http://disk.jabbim.cz/"+self.jid+"/"+unicode(item.text(0).replace(" ", "%20"))+"\n"
			elif self.typ=="album":
				text+="http://album.jabbim.cz/"+self.jid+"/"+unicode(item.text(0).replace(" ", "%20"))+"\n"
			QtGui.QApplication.clipboard().setText(text[:-1])

	def downloadCurrentFile(self):
		#items=self.window.ui.list.selectedItems()
		items=self.wizard.ui.tree.selectedItems()
		if len(items)==0:
			return
		if self.typ=="easyshare":
			contact = self.main.client.getContactByJid(self.jid)
			if contact:
				jid=self.jid+"/"+contact.getHighestResource()
				data=[]
				items=self.wizard.ui.tree.selectedItems()
				for item in items:
					data.append(self.getPath(item))
				self.main.client.callRemote(jid, 'getFiles',(data,))
		else:
			for item in items:
				self.downloadQueue.append(unicode(item.text()))
			f=self.downloadQueue.pop()
			if self.typ=="public":
				self.main.client.sendMessage("public@disk.jabbim.cz", u"get "+self.jid+" "+f)
			elif self.typ=="private":
				self.main.client.sendMessage("private@disk.jabbim.cz", u"get "+self.jid+" "+f)
			elif self.typ=="album":
				self.main.client.sendMessage("album@disk.jabbim.cz", u"get "+self.jid+" "+f)

	def removeCurrentFile(self):
		items=self.wizard.ui.tree.selectedItems()
		if len(items)==0:
			return
		for item in items:
			if self.typ=="public":
				self.main.client.sendMessage("public@disk.jabbim.cz", u"rm "+unicode(item.text()))
			elif self.typ=="private":
				self.main.client.sendMessage("private@disk.jabbim.cz", u"rm "+unicode(item.text()))
			elif self.typ=="album":
				self.main.client.sendMessage("album@disk.jabbim.cz", u"rm "+unicode(item.text()))
		for i in range(len(items)):
			#self.wizard.ui.tree.takeTopLevelItem(self.wizard.ui.tree.indexOfTopLevelItem(items[0]))
			self.wizard.ui.tree.takeItem(self.wizard.ui.tree.row(items[0]))
			del items[0]

	def toNormalSize(self,size):
		if size<0:
			return ""
		original=int(size)
		new=int(size/1000) # kB
		if new==0:
			return str(round(original,2.0))+" B" # B
		size=new
		new=int(size/1000) # MB
		if new==0:
			return str(round(original/1000.0,2))+" kB" # kB
		return str(round(original/1000000.0,2))+" MB" # MB

	def updateView(self, data,parent=None):
		print "updateView",data,self.update
		#if not self.update and not parent:
			#self.window.ui.right.clear()
		self.wizard.ui.tree.clear()
		#if parent:
			#self.window.ui.right.expandItem(parent)
			#self.wizard.ui.tree.expandItem(parent)
			#pass
##		self.window.ui.esPath.setText(self.esPath)
		data=data[0][0]
		self.thumbs={}
		html=""
		for file in data:
			if self.update:
				#items=self.window.ui.right.findItems(file[0],QtCore.Qt.MatchExactly)
				items=self.wizard.ui.tree.findItems(file[0],QtCore.Qt.MatchExactly)
				if len(items)!=0:
					continue
			name=file[0]
			size=int(file[1])
			#if parent:
				#item=QtGui.QListWidgetItem(parent)
				#pass
			#else:
				#item=QtGui.QTreeWidgetItem(self.window.ui.right)
			item=QtGui.QListWidgetItem(self.wizard.ui.tree)

			print unicode(name)
			item.setText(unicode(name))
			#item.setText(1,unicode(self.toNormalSize(size)))
			item.setData(32,QtCore.QVariant(QtCore.QStringList([unicode(size)])))
			if int(size)==-1:
				item.setIcon(QtGui.QIcon(self.pluginDir+"/folder.png"))
				if parent:
					item.path=unicode(parent.path)+name+"/"
			else:
				if parent:
					item.path=unicode(parent.path)+name
				ext=name.split('.')[-1]
				if ext in ["exe","run","sh","bin"]: 
					item.setIcon(QtGui.QIcon(self.pluginDir+"/application-x-executable.png"))
					ic=self.pluginDir+"/application-x-executable.png"
				elif ext in ["svg","jpg","png","gif","tif","tiff","bmp","ico","xcf"]: 
					item.setIcon(QtGui.QIcon(self.pluginDir+"/image-x-generic.png"))
					ic=self.pluginDir+"/image-x-generic.png"
				elif ext in ["wav","mp3","ogg","mp4","flac"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/audio-x-generic.png"))
					ic=self.pluginDir+"/audio-x-generic.png"
				elif ext in ["rar","zip","gz","bz","tgz","deb","rpm","tar","pkg","7z","ace"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/package-x-generic.png"))
					ic=self.pluginDir+"/package-x-generic.png"
				elif ext in ["htm","html","xml"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/text-html.png"))
					ic=self.pluginDir+"/text-html.png"
				elif ext in ["txt","c","py","log"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/text-x-generic.png"))
					ic=self.pluginDir+"/text-x-generic.png"
				elif ext in ["mov","avi","mpg","swf","dv"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/text-x-generic.png"))
					ic=self.pluginDir+"/text-x-generic.png"
				elif ext in ["odt","doc","pdf","docx"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/x-office-document.png"))
					ic=self.pluginDir+"/x-office-document.png"
				elif ext in ["ods","xls","cvs"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/x-office-spreadsheet.png"))
					ic=self.pluginDir+"/x-office-spreadsheet.png"
				elif ext in ["pts","ppt","odp"]:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/x-office-presentation.png"))
					ic=self.pluginDir+"/x-office-presentation.png"
				else:
					item.setIcon(QtGui.QIcon(self.pluginDir+"/text-x-generic-template.png"));  #preventivne pokud se netrefime
					ic=self.pluginDir+"/text-x-generic-template.png"
				html+='<div style=\\"float: left;width: 129px;height:150px;padding: 10px;text-align:center;\\"><a href=\\"http://disk.jabbim.cz/'+self.jid+'/'+unicode(name.replace(" ", "%20"))+'\\"><img src=\\"file:///'+ic.replace("//","/")+'\\"/><p>'+unicode(name)+'</p></a></div>'
			#self.window.ui.right.addItem(item)
			if self.typ=="album":
				self.thumbs[name]=item
		print html
		if self.callTab and self.typ=="public":
			self.callTab.chat.ui.webkit.page().mainFrame().evaluateJavaScript('var group = document.createElement(\'div\'); group.innerHTML="'+html+'";document.getElementById("light").appendChild(group);')
		#self.wizard.ui.tree.resizeColumnToContents(0)
		data=self.thumbs.keys()
		if self.typ=="album" and len(data)!=0:
			self.stopDownload=False
			self.window.ui.progress.setValue(0)
			self.window.ui.progress.setMaximum(len(data))
			self.window.ui.progress.show()
			self.main.client.callRemote('rpc@jabbim.cz/service', 'getThumb', (self.jid,data[0])).addCallback(self.thumbArrived,data)
		if self.update==True:
			self.update=False

	def thumbArrived(self,thumb,data,check=True):
		cacheFile="%s/%s.jpg" % (self.cache,self.jid+data[0])
		if thumb:
			print "saving",data[0],check
			image=base64.decodestring(str(thumb[0]))
			pixmap=QtGui.QPixmap()
			pixmap.loadFromData(image)
			self.thumbs[data[0]].setIcon(QtGui.QIcon(pixmap))
			f=open(cacheFile,"wb")
			f.write(image)
			f.close()
			self.cacheList[cacheFile] = md5(image).hexdigest()
			self.cacheList.write()
		else:
			self.thumbs[data[0]].setIcon(QtGui.QIcon(cacheFile))
		if self.callTab:
			#if self.thumbIndex<10:
			self.callTab.chat.ui.webkit.page().mainFrame().evaluateJavaScript('var group = document.createElement(\'div\'); group.setAttribute("id","image'+str(self.thumbIndex)+'"); group.innerHTML="<div style=\\"float: left;width: 129px;height:150px;padding: 10px;text-align:center;\\"><a href=\\"http://album.jabbim.cz/'+self.jid+'/'+unicode(self.thumbs[data[0]].text().replace(" ", "%20"))+'\\"><img src=\\"file://'+cacheFile+'\\"/><p>'+unicode(self.thumbs[data[0]].text())+'</p></a></div>";document.getElementById("light").appendChild(group);')
			#else:
				#self.callTab.chat.ui.webkit.page().mainFrame().evaluateJavaScript('var group = document.createElement(\'div\'); group.setAttribute("id","image'+str(self.thumbIndex)+'"); group.innerHTML="<div style=\\"float: left;width: 129px;padding: 10px;text-align:center;display:none;\\"><img src=\\"file://'+cacheFile+'\\"/></div>";document.getElementById("light").appendChild(group);')
			self.thumbIndex+=1
		self.window.ui.progress.setValue(self.window.ui.progress.value()+1)
		del data[0]
		if len(data)==0:
			self.thumbs={}
			self.window.ui.progress.hide()

			#if check:
				#data=self.thumbs.keys()
				#self.main.client.callRemote('rpc@jabbim.cz/service', 'getHash', (self.jid,data[0])).addCallback(self.hashArrived,data)
		else:
			if not self.stopDownload:
				cacheFile="%s/%s.jpg" % (self.cache,self.jid+data[0])
				if os.path.isfile(cacheFile):
					self.main.client.reactor.callLater(0,self.thumbArrived,None,data)
				else:
					self.main.client.callRemote('rpc@jabbim.cz/service', 'getThumb', (self.jid,data[0])).addCallback(self.thumbArrived,data)
			else:
				self.stopDownload=False
				self.thumbs={}
				self.window.ui.progress.hide()

	def hashArrived(self,hs,data):
		hs=hs[0][0]
		cacheFile="%s/%s.jpg" % (self.cache,self.jid+data[0])
		download=True
		if self.cacheList.has_key(cacheFile):
			print data[0],hs,self.cacheList[cacheFile]
			if self.cacheList[cacheFile]==hs:
				download=False
		if download:
			self.main.client.callRemote('rpc@jabbim.cz/service', 'getThumb', (self.jid,data[0])).addCallback(self.thumbArrived,[data[0]],False)
		del data[0]
		if len(data)!=0:
			cacheFile="%s/%s.jpg" % (self.cache,self.jid+data[0])
			self.main.client.callRemote('rpc@jabbim.cz/service', 'getHash', (self.jid,data[0])).addCallback(self.hashArrived,data)
		

	def buildMainWindowMenu(self):
		if self.main.isConnected():
			menu=self.mainWindowMenu()
			menu.addAction("Jabbim disk manager",self.showSlot)
	
	def call(self,jid=None,typ=None):
		self.thumbIndex=0
		self.stopDownload=True
		self.wizard.ui.stackedWidget.setCurrentIndex(1)
		self.wizard.ui.back.show()
##		self.window.ui.label_size.setText("")
##		self.window.ui.label_name.setText("")
		if typ:
			self.typ=typ
		if jid:
			self.jid=jid
			self.window.ui.line_jid.setText(self.jid)
		#else:
			#self.jid=unicode(self.window.ui.line_jid.text())
			#self.jid=unicode(self.main.client.jid.userhost())
		print "call",self.jid,self.typ
		if self.typ=="public":
			self.main.client.callRemote('rpc@jabbim.cz/service', 'listPublic', (self.jid,)).addCallback(self.updateView)
			self.wizard.ui.remove.show()
			self.wizard.ui.upload.show()
			self.wizard.ui.configuration.hide()
##			self.window.ui.list.setIconSize(QtCore.QSize(32,32))
##			self.window.ui.list.setGridSize(QtCore.QSize(128,96))
##			self.window.ui.esWidget.hide()
		elif self.typ=="private":
			self.main.client.callRemote('rpc@jabbim.cz/service', 'listPrivate', (self.jid,)).addCallback(self.updateView)
			self.wizard.ui.remove.show()
			self.wizard.ui.upload.show()
			self.wizard.ui.configuration.hide()
##			self.window.ui.list.setIconSize(QtCore.QSize(32,32))
##			self.window.ui.list.setGridSize(QtCore.QSize(128,96))
##			self.window.ui.esWidget.hide()
		elif self.typ=="album":
			self.main.client.callRemote('rpc@jabbim.cz/service', 'listAlbum', (self.jid,)).addCallback(self.updateView)
			self.wizard.ui.remove.show()
			self.wizard.ui.upload.show()
			self.wizard.ui.configuration.hide()
##			#if self.config['iconMode']=="True":
##			self.window.ui.list.setIconSize(QtCore.QSize(128,128))
##			self.window.ui.list.setGridSize(QtCore.QSize(160,160))
##			self.window.ui.esWidget.hide()
		else:
			self.wizard.ui.remove.hide()
			self.wizard.ui.upload.hide()
			self.wizard.ui.configuration.show()

		if self.jid != self.main.client.jid.userhost():
			self.window.ui.buttonDelete.setEnabled(False)
			self.window.ui.buttonUpload.setEnabled(False)
			self.window.ui.privateButton.setEnabled(False)
			self.wizard.ui.remove.setEnabled(False)
			self.wizard.ui.upload.setEnabled(False)
			self.wizard.ui.private.setEnabled(False)
		else:
			self.window.ui.buttonDelete.setEnabled(True)
			self.window.ui.buttonUpload.setEnabled(True)
			self.window.ui.privateButton.setEnabled(True)
			self.wizard.ui.remove.setEnabled(True)
			self.wizard.ui.upload.setEnabled(True)
			self.wizard.ui.private.setEnabled(True)
	

	def buildMainWindowToolBar(self):
		self.toolBarButton = self.mainWindowToolBarAction(QtGui.QIcon("%s/jdisk-public-24.png" % self.pluginDir),"",self.showSlot)

	def showSlot(self,jid=None,typ=None):
		self.wizard.show()
##		if self.main.client.isVip:
##			self.window.ui.vipInfo.hide()
##		else:
##			self.window.ui.vipInfo.show()
		self.wizard.ui.tree.clear()
		if (not self.main.client.roster['users'].has_key("public@disk.jabbim.cz") or not self.main.client.roster['users'].has_key("private@disk.jabbim.cz")) or not self.main.client.roster['users'].has_key("album@disk.jabbim.cz"):
			d=self.main.client.getRegisterForm("disk.jabbim.cz")
			d.addCallback(self._onRegister)
		if jid:
			self.jid=jid
			self.window.ui.line_jid.setText(self.jid)
		else:
			#self.jid=unicode(self.window.ui.line_jid.text())
			self.jid=unicode(self.main.client.jid.userhost())
		self.wizard.setWindowTitle(unicode(self.jid))
		self.wizard.ui.private.setEnabled(self.jid==self.main.client.jid.userhost())
		if typ:
			self.call(jid,typ)
			self.window.ui.buttonDownload.setEnabled(False)
			self.wizard.ui.back.show()
		else:
			self.wizard.ui.stackedWidget.setCurrentIndex(0)
			self.wizard.ui.back.hide()

	def _onRegister(self,data):
		if not data:
			return
		jid,legacy,form=data
		if form!=None:
			self.dialog=dataforms.dataFormsDialog(self.main,form,jid,"register",self)
			self.dialog.show()
		else:
			self.dialog=legacyforms.legacyFormsDialog(self.main,legacy,jid,"disco",self.window)
			self.dialog.show()
	
	def on_message(self,msg):
		frm, typ, body, subject ,  xhtml,chatstate ,  delay, error = msg.legacyUnpack()
		if self.typ=="public":
			text="public@disk.jabbim.cz"
		elif self.typ=="private":
			text="private@disk.jabbim.cz"
		elif self.typ=="album":
			text="album@disk.jabbim.cz"
		else:
			return True
		if unicode(frm).find(text)!=-1:
			if not self.window.isHidden() or not self.wizard.isHidden():
				return False
		return True

	def on_ftEnd(self, sid, error = None): #pokud je error None je vse v poradku, jinak strucny popis chyby.
		if not self.window.isHidden() or not self.wizard.isHidden():
			if self.typ=="public":
				text="public@disk.jabbim.cz"
			elif self.typ=="private":
				text="private@disk.jabbim.cz"
			elif self.typ=="album":
				text="album@disk.jabbim.cz"
			else:
				return
			filename=unicode(self.main.client.ft[sid].filepath)
			if error == None and self.main.client.ft[sid].tojid.full().find(text)!=-1 and not filename in self.filesToOpen:
				self.update=True
				self.call(typ=self.typ)
			if filename in self.filesToOpen:
				self.filesToOpen.remove(filename)
				if self.main.allowedJids.has_key(text+"/"+self.main.client.ft[sid].fileprops['name']):
					del self.main.allowedJids[text+"/"+self.main.client.ft[sid].fileprops['name']]
				if error==None:
					if sys.platform == 'win32':
						filename=filename.replace("/","\\")
						print "open win32",[filename]
						os.startfile(filename)
					else:
						print "open linux",[filename]
						os.system(u"xdg-open \"%s\"" % filename.encode('utf8'))
					if self.main.events.ftEvents.has_key(sid):
						self.main.events.ftEvents[sid].reject()
						self.wizard.ui.back.hide()
						self.wizard.ui.stackedWidget.setCurrentIndex(0)
			try:
				f=self.downloadQueue.pop()
			except:
				f=None
			if f:
				if self.typ=="public":
					self.main.client.sendMessage("public@disk.jabbim.cz", u"get "+self.jid+" "+f)
				elif self.typ=="private":
					self.main.client.sendMessage("private@disk.jabbim.cz", u"get "+self.jid+" "+f)
				elif self.typ=="album":
					self.main.client.sendMessage("album@disk.jabbim.cz", u"get "+self.jid+" "+f)

	def selectionChanged(self):
		items=self.wizard.ui.tree.selectedItems()
		if len(items)!=0:
			if len(items)==1:
				item=items[0]
				self.wizard.ui.filename.setText(item.text())
				data=item.data(32).toList()
				size=int(data[0].toString())
				if size==-1:
					self.wizard.ui.filename.setText(self.tr("Folder"))
					self.wizard.ui.remove.setEnabled(False)
					self.wizard.ui.download.setEnabled(False)
				else:
					self.wizard.ui.filesize.setText(self.toNormalSize(size))
					self.wizard.ui.remove.setEnabled(self.jid==self.main.client.jid.userhost())
					self.wizard.ui.download.setEnabled(True)
				self.wizard.ui.image.setPixmap(item.icon().pixmap(128,128))
			else:
				self.wizard.ui.filename.setText(unicode(len(items))+self.tr(" files"))
				size=0
				for it in items:
					data=it.data(32).toList()
					size+=int(data[0].toString())
				self.wizard.ui.filesize.setText(self.toNormalSize(size))
				
				
		else:
			self.wizard.ui.remove.setEnabled(False)
			self.wizard.ui.download.setEnabled(False)
			self.wizard.ui.filename.setText("")
			self.wizard.ui.filesize.setText("")

	def getPath(self,item):
		#path=""
		#parents=[item]
		#parent=item.parent()
		#while parent:
			#parents.append(parent)
			#parent=parent.parent()
		#parents.reverse()
		#for parent in parents:
			#path+=unicode(parent.text(0))+"/"
		return unicode(item.path)
		#return path[:-1]

	def doubleClicked(self,item,col=None):
		if self.typ=="public":
			self.main.allowedJids["public@disk.jabbim.cz/"+unicode(item.text(0))]=self.cache
			self.main.client.sendMessage("public@disk.jabbim.cz", u"get "+self.jid+" "+unicode(item.text(0)))
			self.filesToOpen.append(self.cache+"/"+unicode(item.text(0)))
		elif self.typ=="private":
			self.main.allowedJids["private@disk.jabbim.cz/"+unicode(item.text(0))]=self.cache
			self.main.client.sendMessage("private@disk.jabbim.cz", u"get "+self.jid+" "+unicode(item.text(0)))
			self.filesToOpen.append(self.cache+"/"+unicode(item.text(0)))
		elif self.typ=="album":
			self.main.allowedJids["album@disk.jabbim.cz/"+unicode(item.text(0))]=self.cache
			self.main.client.sendMessage("album@disk.jabbim.cz", u"get "+self.jid+" "+unicode(item.text(0)))
			self.filesToOpen.append(self.cache+"/"+unicode(item.text(0)))
		elif self.typ=="easyshare":
			contact = self.main.client.getContactByJid(self.jid)
			if contact:
				jid=self.jid+"/"+contact.getHighestResource()
				print self.getPath(item)
				self.main.client.callRemote(jid, 'listShare',(self.getPath(item),)).addCallback(self.updateView,item)

		
